-- create parser with "happy -g -a -c MapParser.y"
{{-
Part of "Haski the Robot"
examination project for adv. funct. progr. 2004

    Copyright (C) 2004  Lars Otten

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

-}

{-

  I M P O R T A N T  ! ! !
----------------------------
after creating the parser with happy make the following change
at the end of the definition of
"happyNewToken action sts stk (tk:tks)":
Change the line
	_ -> happyError tks
to
	_ -> happyError (tk:tks)

-}

module MapParser(
		mapParser,	-- the actual parsing function
		MapData(..),	-- data structure for the map info
		LexE(..)	-- Monad for handling errors in parsing
		) where

import MapLexer
import ErrorMonad

}

%name parse
%tokentype { MToken }
%monad { LexE }

%token
	','		{ T _ _ TComma }
--	';'		{ T _ _ TBREAK }
	'('		{ T _ _ TBO }
	')'		{ T _ _ TBC }
	r		{ T _ _ TRobot }
	i		{ T _ _ TItem }
	int		{ T _ _ (TInt $$) }





%%

Main	:: { [MapData] }
	: {- empty -}				{ [] }
	| Main ',' Item				{ $1 ++ [$3] }
	| Main Item				{ $1 ++ [$2] }

Item	:: { MapData }
	: MTuple				{ Wall $1 }
	| r MTriple				{ Robot $2 }
	| i MTuple				{ Item $2 }

MTuple	:: { (Int,Int) }
	: '(' int ',' int ')'			{ ( $2, $4 ) }

MTriple	:: { (Int,Int,Int) }
	: '(' int ',' int ',' int ')'		{ ( $2, $4, $6 ) }


{

happyError :: [MToken] -> LexE a
happyError ((T p s _):ts) = Failed ("Line " ++ getLineNo p
               ++ ": Parse error on string \"" ++ s ++ "\"")
  where getLineNo (AlexPn _ l _) = show l
happyError _ = Failed ("Parsing failed on end of file")

-------------------------------------------
-- output data type

data MapData
 = Wall (Int,Int)
 | Robot (Int,Int,Int)
 | Item (Int,Int)


-- main parsing function
mapParser input = lexer input >>= parse

}
